#!/usr/bin/env python3
from math import hypot ; from typing import List, Tuple

Point = Tuple[float, float]
Shape = List[Tuple]

def sub(a:Point, b:Point): return [a[0]-b[0], a[1]-b[1]]
def crz(a:Point, b:Point): return a[1]*b[0] - a[0]*b[1]

def dist(p:Point, a:Point, b:Point):
    l = hypot(a[0]-b[0],a[1]-b[1])
    u = abs(p[0]*(b[1]-a[1]) - p[1]*(b[0]-a[0]) + crz(a,b))
    return u / l

def diameter(h:Shape):
    if len(h) <= 2:
        return 0.0

    d = 1e40
    a = 0
    b = 1
    for a in range(len(h)):
        aa = (a+1) % len(h)
        while True:
            bb = (b+1) % len(h)
            if b in [a, aa] or (dist(h[bb], h[a], h[aa]) >= dist(h[b], h[a], h[aa])): b = bb
            else: break
        d = min(d, dist(h[b], h[a], h[aa]))
    return d

n = int(input())
v = sorted(list(map(lambda _: list(map(float, input().split())), range(n))))
h1,h2 = [], []
for i in v:
    while len(h1) >= 2 and crz(sub(h1[-1],h1[-2]), sub(i, h1[-2])) >= 0: h1.pop()
    while len(h2) >= 2 and crz(sub(h2[-1],h2[-2]), sub(i, h2[-2])) <= 0: h2.pop()
    h1 += [i]
    h2 += [i]
hull = h1[:-1] + h2[:0:-1]
print(diameter(hull))
