#!/usr/bin/env python3
from math import hypot ; from typing import List, Tuple

Point = Tuple[float, float]
Shape = List[Tuple]

def sub(a:Point, b:Point): return [a[0]-b[0], a[1]-b[1]]
def crz(a:Point, b:Point): return a[1]*b[0] - a[0]*b[1]

def dist(p:Point, a:Point, b:Point):
    l = hypot(a[0]-b[0],a[1]-b[1])
    u = abs(p[0]*(b[1]-a[1]) - p[1]*(b[0]-a[0]) + crz(a,b))
    return u / l

def min_width(h:Shape):
  if len(h) <= 2:
      return 0.0

  res = 1e40
  for a in h:
    for b in h:
      if a is not b:
        d = 0.0
        for i in h:
          d = max(d, dist(i,a,b))
        res = min(res, d)
  return res

n = int(input())
v = list(map(lambda _: list(map(float, input().split())), range(n)))
print(min_width(v))
