#include <unordered_map>/*{{{*/
#include <algorithm>
#include <iostream>
#include <cstdint>
#include <fstream>
#include <sstream>
#include <cassert>
#include <string>
#include <vector>
#include <stack>
#include <set>
#include <map>
using namespace std;/*}}}*/

enum JudgeCode:int{
  judge_error=1,
  correct=42,
  wrong_answer=43,
};

int main(int argc, char **argv){
  if (argc<3){
    cerr<<"usage: "<<argv[0]<<" testcase.in testcase.ans < team.out"<<endl;
    return judge_error;
  }
  else if (argc>3){
    cerr<<"warning: ignoring "<<argc-3<<" extra arguments"<<endl;
  }

  // Standard boilerplate- get input, answer, and output
  ifstream canonical_input(argv[1]);
  ifstream canonical_output(argv[2]);
  auto &team_output = cin;

  // Parse official input.
  set<int64_t> valid_numbers;
  uint64_t n; canonical_input>>n;
  for (auto i=n; i--;) {uint64_t v; canonical_input>>v; valid_numbers.insert(v);}
  int64_t tree; canonical_input>>tree;

  int64_t correct_answer; canonical_output>>correct_answer;
  int64_t correct_value=tree%correct_answer;

  int64_t team_answer; if (not (team_output>>team_answer)){
    cout<<"Team didn't print a number"<<endl;
    return wrong_answer;
  }

  if (not valid_numbers.count(team_answer)){
    cout<<"Team output "<<team_answer<<" isn't in the input"<<endl;
    return wrong_answer;
  }

  if (team_answer==0){
    cout<<"Team output 0."<<endl;
    return wrong_answer;
  }

  int64_t team_value=tree%team_answer;
  if (team_value<correct_value){
    cout<<"Correct score is " <<correct_value<<" with "<<correct_answer
        <<" but team got "<<team_value<<" with "<<team_answer<<endl;
    return judge_error;
  }
  if (team_value>correct_value){
    cout<<"Correct score is " <<correct_value<<" with "<<correct_answer
        <<" but team score is "<<team_value<<endl;
    return wrong_answer;
  }

  cout<<"OK both answers score "<<correct_value<<endl;
  return correct;
}
