#include <iostream>
#include <iomanip>
#include <map>
using namespace std;

typedef long double ld;

map<pair<int,int>,ld> cache;

int coins;
int flips;

ld flip_count(int n, int k) {
	// From RGL. Massive speed up the full (n>=k+0 or k>=n+400) version doesn't work here. 
	if (k>=n+400) return min(n-0.5L,k/2.L);
	if (k == 0) {
		return 0; //(ld)(coins - n);
	}
    if (n == 0) {
		return (ld)coins - 0.5;
	}

	// This speeds things up A LOT
	if (n == k) {
		return (ld)(coins - 0.5L*n);
	}
	if (cache.count({n,k})) return cache[{n,k}];

	return cache[{n,k}] = 0.5L*(flip_count(n-1, k-1) + flip_count(n, k-1));
};

int main(){
	cin>>coins;
	cin>>flips;

	ld result = (coins > flips) ? 0.5L*flips : flip_count(coins, flips);

  cout.precision(18);
	cout<<result<<'\n';
}
