#include <bits/stdc++.h>
using namespace std;

struct Range{/*{{{*/
  int weight;
  int strength;
};/*}}}*/

vector<Range> read_cranes(){/*{{{*/
  int n; cin>>n;
  vector<Range> cranes(n);
  for (auto &i: cranes){
    cin>>i.weight>>i.strength;
  }
  return cranes;
}/*}}}*/

vector<int> read_buildings(){/*{{{*/
  int n; cin>>n;
  vector<int> buildings(n);
  for (auto &i: buildings){
    cin>>i;
  }
  return buildings;
}/*}}}*/

struct BinaryGraph{/*{{{*/
  public:
    vector<set<int>> edges;

    bool find_level_graph(int s,int t,vector<int> &dist){
      for (auto &i: dist) i=-1;
      queue<int> todo; todo.push(s); dist[s]=0;
      while (not todo.empty()){
        int x=todo.front(); todo.pop();
        for (auto y: edges[x]){
          if (!~dist[y]){
            dist[y]=dist[x]+1;
            if (y==t) return true;
            todo.push(y);
          }
        }
      }
      return false;
    }

    int dfs(int s,int t,vector<int> &dist,int cap=(1<<28),vector<int> *into=nullptr){
      if (s==t or cap==0) return cap;
      if (dist[s]==-1) return 0;
      int res=0;
      for (auto y=edges[s].begin(); y!=edges[s].end();){
        if (dist[*y]==dist[s]+1){
          int got=dfs(*y,t,dist,min(cap-res,1));
          if (got){
            edges[*y].insert(s);
            edges[s].erase(y++);
            res+=got;
            continue;
          }
        }
        ++y;
      }
      if (res<cap) dist[s]=-1;
      return res;
    }

  public:
    BinaryGraph(int vertices): edges(vertices){
      return;
    }

    void add_edge(int a,int b){
      edges[a].insert(b);
    }

    void remove_edge(int a,int b){
      edges[a].erase(b);
    }

    int max_flow(int s,int t){
      int res=0;
      vector<int> dist(edges.size());
      while (find_level_graph(s,t,dist)){
        int got=dfs(s,t,dist);
        res+=got;
      }
      return res;
    }
};/*}}}*/

int main(){
  vector<Range> const cranes=read_cranes();
  vector<int> const buildings=read_buildings();

  BinaryGraph g(2+cranes.size()*2+buildings.size());
  for (int i=0; i<cranes.size(); i++){
    // Source edge.
    if (cranes[i].weight==0){
      g.add_edge(0,2+i*2+0);
    }

    // Internal edge.
    g.add_edge(2+i*2+0,2+i*2+1);

    // Edges to other cranes.
    for (int j=0; j<cranes.size(); j++){
      if (cranes[i].strength>=cranes[j].weight){
        g.add_edge(2+i*2+1,2+j*2+0);
      }
    }

    // Edges to buildings.
    for (int j=0; j<buildings.size(); j++){
      if (cranes[i].strength>=buildings[j]){
        g.add_edge(2+i*2+1,2+cranes.size()*2+j);
      }
    }
  }

  // Terminal edges.
  for (int i=0; i<buildings.size(); i++){
    g.add_edge(2+cranes.size()*2+i,1);
  }

  BinaryGraph original=g;
  int mf=g.max_flow(0,1);
  if (mf!=buildings.size()){
    cout<<"impossible"<<endl;
    return 0;
  }

  for (int i=0; i<buildings.size(); i++){
    vector<int> res;
    for (int j=2+cranes.size()*2+i; j!=-1; j){
      int k=-1;
      for (int z: g.edges[j])
        if (original.edges[z].count(j))
          k=z;
      if (j>=2 and j<2+cranes.size()*2 and (j%2==1) and k+1==j){
        res.push_back((j-2)/2);
      }
      j=k;
    }
    for (int j=res.size(); j--;) cout<<res[j]+1<<(j?' ':'\n');
  }
}
