#include <iostream>
#include <utility>
#include <vector>
using namespace std;

vector<vector<int>> edge;
vector<int> back;
vector<bool> visited;

bool dfs(int i,int n,bool rev=false){
  if (i>=n) return true;
  if (visited[i*2+rev]) return false; else visited[i*2+rev]=true;

  if (back[i]==-1 or rev){
    for (int j: edge[i])
      if (back[j]!=i){
        if (dfs(j,n)){
          back[j]=i;
          return true;
        }
      }
  }

  if (back[i]!=-1){
    if (dfs(back[i],n,true)){
      back[i]=-1;
      return true;
    }
  }

  return false;
}

int main(){
  int n; cin>>n;
  vector<pair<int,int>> c(n);
  for (auto &i: c) cin>>i.first>>i.second;

  int m; cin>>m;
  vector<int> b(m);
  for (auto &i: b) cin>>i;

  edge.resize(n+m+2);
  back.assign(n+m+2,-1);
  for (int i=n; i--;)
    if (c[i].first==0)
      edge[0].push_back(i+1);
  for (int i=n; i--;)
    for (int j=n; j--;)
      if (i!=j and c[j].first<=c[i].second and c[i].second<c[j].second)
        edge[1+i].push_back(1+j);
  for (int i=n; i--;)
    for (int j=m; j--;)
      if (c[i].second>=b[j])
        edge[1+i].push_back(1+n+j);
  for (int i=m; i--;)
    edge[1+n+i].push_back(1+n+m);

  for (int step=0; step<m; step++){
    visited.assign((n+m+2)*2,false);
    back[0]=-1;
    if (not dfs(0,n+m+1)){
      cout<<"impossible"<<endl;
      return 0;
    }
  }

  cerr<<"possible"<<endl;
  for (int i=n+1; i<=n+m; i++){
    vector<int> r={i}; while (back[r.back()]) r.push_back(back[r.back()]);
    for (int j=r.size(); j-->1;) cout<<r[j]<<(j-1?' ':'\n');
    cerr<<"  |"; for (int j=r.size(); j-->1;) cerr<<c[r[j]-1].first<<","<<c[r[j]-1].second<<(j-1?"  ":""); cerr<<endl;
  }
}
