#include <bits/stdc++.h>
using namespace std;

bool constexpr debug=false;

int n;
vector<pair<int,int>> res;

void write_swap(int a,int b,bool const rev){
  if (min(a,b)<0 or max(a,b)>=n) return;
  if (rev) swap(a,b);
  res.emplace_back(a,b);
}

vector<vector<int>> get_permutation_cycles(vector<int> permutation){
  vector<vector<int>> res;
  for (int i=0; i<permutation.size(); i++){
    if (permutation[i]!=-1){
      vector<int> loop;
      for (int j=i,to=-1; permutation[j]!=-1; j=to,to=-1){
        swap(to,permutation[j]);
        loop.push_back(j);
      }
      res.push_back(loop);
    }
  }
  return res;
}

// Generates a network to turn a sorted list into a specific word, eg. aaabnn -> banana
void generate_reorder(string const word){
  vector<int> permutation(n);
  for (int i=0; i<n; i++) permutation[i]=i;
  sort(permutation.begin(),permutation.end(),[&word](int a,int b){return word[a]<word[b];});

  string sorted_word=word;
  sort(sorted_word.begin(),sorted_word.end());

  for (vector<int> const loop: get_permutation_cycles(permutation)){
    for (size_t i=0,j=loop.size(); j-->1; i=j){
      write_swap(loop[i],loop[j],sorted_word[loop[i]]<sorted_word[loop[j]]);
      swap(sorted_word[loop[i]],sorted_word[loop[j]]);
    }
  }
}

int main(){
  string word; cin>>word;
  n=word.length();

  generate_reorder(word);

  for (auto i: res){
    cout<<i.first+1<<" "<<i.second+1<<endl;
  }
  if (debug){
    cerr<<"STEPS: "<<res.size()<<" for "<<n<<endl;
  }
}
