#include <bits/stdc++.h>
using namespace std;

bool constexpr debug=false;

int n;
vector<pair<int,int>> res;

string simulate(string w,vector<pair<int,int>> moves){
  for (auto i: moves){
    if (w[i.second]<w[i.first]){
      swap(w[i.first],w[i.second]);
    }
  }
  return w;
}

size_t power_of_two(size_t v){
  for (size_t i=1; i<=4; i++) v&=~(v>>(1<<i));
  return v;
}

void write_swap(size_t a,size_t b,bool const rev){
  if (min(a,b)<0 or max(a,b)>=n) return;
  if (rev) swap(a,b);
  res.emplace_back(a,b);
}

// Generates a bitonic sort, eg. 43152 -> 12345
void generate_sort(size_t const b){
  for (size_t span=2; span<=b; span<<=1){
    for (size_t shift=span>>1; shift; shift>>=1){
      for (size_t i=0; i+shift<b; i++){
        write_swap(i,i+shift,(i/span)%2);
      }
    }
  }
}

vector<vector<int>> get_permutation_cycles(vector<int> permutation){
  vector<vector<int>> res;
  for (int i=0; i<permutation.size(); i++){
    if (permutation[i]!=-1){
      vector<int> loop;
      for (int j=i,to=-1; permutation[j]!=-1; j=to,to=-1){
        swap(to,permutation[j]);
        loop.push_back(j);
      }
      res.push_back(loop);
    }
  }
  return res;
}

// Generates a network to turn a sorted list into a specific word, eg. aaabnn -> banana
void generate_reorder(string const word){
  vector<int> permutation(n);
  for (int i=0; i<n; i++) permutation[i]=i;
  sort(permutation.begin(),permutation.end(),[&word](int a,int b){return word[a]<word[b];});

  string sorted_word=word;
  sort(sorted_word.begin(),sorted_word.end());

  for (vector<int> const loop: get_permutation_cycles(permutation)){
    for (size_t i=0,j=loop.size(); j-->1; i=j){
      write_swap(loop[i],loop[j],sorted_word[loop[i]]<sorted_word[loop[j]]);
      swap(sorted_word[loop[i]],sorted_word[loop[j]]);
    }
  }
}

template <class C>
bool sorted(C begin,C end){
  if (begin!=end){
    for (auto i=begin,j=i++; i!=end; j=i++){
      if (*i<*j) return false;
    }
  }
  return true;
}

template <class C>
bool sorted(C const &s){
  return sorted(s.begin(),s.end());
}

int main(){
  string word; cin>>word;
  n=word.length();

  generate_sort(power_of_two(n*2));

  if (debug){/*{{{*/
    for (int trials=500; trials--;){
      string ward=word;
      for (int i=n+10; i--;)
        swap(ward[rand()%n],ward[rand()%n]);
      assert(sorted(simulate(ward,res)));
    }
  }/*}}}*/

  generate_reorder(word);

  if (debug){/*{{{*/
    for (int trials=500; trials--;){
      string ward=word;
      for (int i=n+10; i--;)
        swap(ward[rand()%n],ward[rand()%n]);
      assert(simulate(ward,res)==word);
    }
  }/*}}}*/

  for (auto i: res){
    cout<<i.first+1<<" "<<i.second+1<<endl;
  }
  if (debug){
    cerr<<"STEPS: "<<res.size()<<" for "<<n<<endl;
  }
}
