#!/usr/bin/env python

#
# This solution does 2 passes: 
# - the first pass follows X-Y-Z from source to target for both,
# ignoring collisions of robots ('move_xyz')
# - the second pass fixes collisions ('untangle' call)

walks = [[],[]]

def finished(robot):
  return robot[0] == robot[1]

def move_xyz(robot):
    if (robot[0][0] == robot[1][0]):
        p1 = robot[0][0]
        if (robot[0][1] == robot[1][1]):
            p2 = robot[0][1]
            if (robot[0][2] == robot[1][2]):
                p3 = robot[0][2]
            else:
                p3 = robot[0][2]-1 if robot[0][2]>robot[1][2] else robot[0][2]+1
        else:
            p2 = robot[0][1]-1 if robot[0][1]>robot[1][1] else robot[0][1]+1
            p3 = robot[0][2]
    else:
        p1 = robot[0][0]-1 if robot[0][0]>robot[1][0] else robot[0][0]+1
        p2 = robot[0][1]
        p3 = robot[0][2]
    return [p1,p2,p3]

def read_robot(name):
  l = map(int, raw_input().split())
  return [l[:3], l[3:]]

def format_bot(robot):
  return '(%d %d %d)' % (robot[0], robot[1], robot[2])

def print_bots(*robots):
  print ' '.join(map(format_bot, robots))

def print_bots(*robots):
  print ' '.join(map(format_bot, robots))

# t - time of conflict
# i - robot (0 or 1) to move
# one_finished (True = (1-i) robot is done and will not move
def untangle(t,i,one_finished):
    # 3 steps of robot
    x = walks[i][t-1][0]-walks[i][t][0]
    y = walks[i][t-1][1]-walks[i][t][1]
    z = walks[i][t-1][2]-walks[i][t][2]
    if abs(x): # move along y then x
        detour1 = [walks[i][t-1][0],walks[i][t-1][1]+1,walks[i][t-1][2]]
        detour2 = [walks[i][t-1][0]-x,walks[i][t-1][1]+1,walks[i][t-1][2]]
        detour3 = [walks[i][t-1][0]-2*x,walks[i][t-1][1]+1,walks[i][t-1][2]]
    elif abs(y): # move along z then y
        detour1 = [walks[i][t-1][0],walks[i][t-1][1],walks[i][t-1][2]+1]
        detour2 = [walks[i][t-1][0],walks[i][t-1][1]-y,walks[i][t-1][2]+1]
        detour3 = [walks[i][t-1][0],walks[i][t-1][1]-2*y,walks[i][t][2]+1]
    else: # move along x then z
        detour1 = [walks[i][t-1][0]+1,walks[i][t-1][1],walks[i][t-1][2]]
        detour2 = [walks[i][t-1][0]+1,walks[i][t-1][1],walks[i][t-1][2]-z]
        detour3 = [walks[i][t-1][0]+1,walks[i][t-1][1],walks[i][t-1][2]-2*z]
    if one_finished:
        del(walks[i][t])
    walks[i].insert(t,detour1)
    walks[i].insert(t+1,detour2)
    if one_finished:
        walks[i].insert(t+2,detour3)
    end = walks[1-i][-1]
    for j in range(max(len(walks[0]),len(walks[1])) - (min(len(walks[0]),len(walks[1])))):
        walks[1-i].append(end)
    if walks[0][-1] == walks[0][-2] and walks[1][-1] == walks[1][-2]:
        walks[0].pop()
        walks[1].pop()

robots = map(read_robot, range(2))
step = 0
walks[0].append(robots[0][0])
walks[1].append(robots[1][0])
res = map(move_xyz,robots)

while sum(map(finished, robots)) < 2:
  step += 1
  nobots = map(move_xyz, robots)
  robots[0][0] = nobots[0]
  robots[1][0] = nobots[1]
  walks[0].append(nobots[0])
  walks[1].append(nobots[1])
  #print_bots(*nobots)

for t in(range(1,len(walks[0]))):
    #clash
    if walks[0][t] == walks[1][t]:
        if walks[0][t-1] == walks[0][t]:
            untangle(t,1,True)
        elif walks[1][t-1] == walks[1][t]:
            untangle(t,0,True)
        else:
            untangle(t,0,False)
    #swap
    elif (walks[0][t] == walks[1][t-1] and walks[1][t] == walks[0][t-1]):
        if t<len(walks[0]) and walks[0][t] != walks[0][t-1]:
            untangle(t,0,False)
        else:
            untangle(t,1,False)

for t in range(len(walks[0])):
    print_bots(walks[0][t],walks[1][t])
