#include <bits/stdc++.h>
using namespace std;

struct vec3{
  int x,y,z;

  bool operator==(vec3 const &a)const{return x==a.x and y==a.y and z==a.z;}
  bool operator!=(vec3 const &a)const{return x!=a.x or y!=a.y or z!=a.z;}
  vec3 operator+(vec3 const &a)const{return {x+a.x,y+a.y,z+a.z};}
  vec3 operator-(vec3 const &a)const{return {x-a.x,y-a.y,z-a.z};}
  bool operator<(vec3 const &a)const{return x!=a.x?x<a.x:y!=a.y?y<a.y:z<a.z;}
  int man()const{return abs(x)+abs(y)+abs(z);}

  void move_towards(vec3 const &a){
    if (a.x!=x) x+=(a.x>x?1:-1); else
    if (a.y!=y) y+=(a.y>y?1:-1); else
    if (a.z!=z) z+=(a.z>z?1:-1);
  }

  friend ostream& operator<<(ostream& s, vec3 const &v){
    return s<<"("<<v.x<<" "<<v.y<<" "<<v.z<<")";
  }
};

bool safe(vec3 const &a,vec3 const &b,vec3 const &a2,vec3 const &b2){
  return (a-a2).man()+1<(b-a2).man() or (b-b2).man()+1<(a-b2).man() or a==a2 and b==b2;
}

stack<pair<vec3,vec3>> pending_moves;
static set<pair<vec3,vec3>> did;
bool dfs(vec3 a,vec3 b,vec3 const &ao,vec3 const &bo,vec3 const &a2,vec3 const &b2,
    int const max_depth){
  if ((a-ao).man()>5 or (b-bo).man()>5) return false;
  if (not did.count({a,b})) did.insert({a,b}); else return false;
  static vec3 const dirns[6]={{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1}};

  if (safe(a,b,a2,b2) and (a-a2).man()+(b-b2).man()<=(ao-a2).man()+(bo-b2).man()) return true;
  if (max_depth==0) return false;

  for (auto const &u: dirns){
    for (auto const &v: dirns){
      if (a+u==b and b+v==a or a+u==b+v) continue;
      if (dfs(a+u,b+v,ao,bo,a2,b2,max_depth-1)){
        pending_moves.emplace(a+u,b+v);
        return true;
      }
    }
  }
  return false;
}

int main(){
  vec3 a,b,a2,b2;
  cin>>a.x>>a.y>>a.z>>a2.x>>a2.y>>a2.z;
  cin>>b.x>>b.y>>b.z>>b2.x>>b2.y>>b2.z;

  cout<<a<<" "<<b<<endl;
  while (a!=a2 or b!=b2){
    if ((a-b).man()>2 or safe(a,b,a2,b2)){
      a.move_towards(a2);
      b.move_towards(b2);
      cout<<a<<" "<<b<<endl;
    }else{
      constexpr int max_depth=15;
      for (int depth=1; depth<=max_depth; depth++){
        did.clear();
        if (dfs(a,b,a,b,a2,b2,depth)) break;
        assert(depth<max_depth);
      }
      while (not pending_moves.empty()){
        a=pending_moves.top().first, b=pending_moves.top().second;
        pending_moves.pop();
        cout<<a<<" "<<b<<endl;
      }
    }
  }
}
