#include <bits/stdc++.h>
using namespace std;

struct vec3{
  int x,y,z;

  bool operator==(vec3 const &a)const{return x==a.x and y==a.y and z==a.z;}
  bool operator!=(vec3 const &a)const{return x!=a.x or y!=a.y or z!=a.z;}
  vec3 operator+(vec3 const &a)const{return {x+a.x,y+a.y,z+a.z};}
  vec3 operator-(vec3 const &a)const{return {x-a.x,y-a.y,z-a.z};}
  bool operator<(vec3 const &a)const{return x!=a.x?x<a.x:y!=a.y?y<a.y:z<a.z;}
  int man()const{return abs(x)+abs(y)+abs(z);}

  friend ostream& operator<<(ostream& s, vec3 const &v){
    return s<<"("<<v.x<<" "<<v.y<<" "<<v.z<<")";
  }
};

static stack<pair<vec3,vec3>> pending_moves;
static set<pair<vec3,vec3>> did;
bool pfs(vec3 a,vec3 b,vec3 const &ao,vec3 const &bo,vec3 const &a2,vec3 const &b2){
  if (not did.count({a,b})) did.insert({a,b}); else return false;
  if (a==a2 and b==b2) return true;

  static vec3 const dirns[7]={{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1},{0,0,0}};
  vector<pair<vec3,vec3>> moves;
  for (auto const &u: dirns)
    for (auto const &v: dirns)
      moves.emplace_back(u,v);
  sort(moves.begin(),moves.end(),[a,b,a2,b2](pair<vec3,vec3> const &u,pair<vec3,vec3> const &v){
    return (a+u.first-a2).man()+(b+u.second-b2).man() < (a+v.first-a2).man()+(b+v.second-b2).man();
  });

  for (auto const &uv: moves){
    auto const &u=uv.first;
    auto const &v=uv.second;
    if (a+u!=b+v and (a+u!=b or b+v!=a) and pfs(a+u,b+v,ao,bo,a2,b2))
      return pending_moves.emplace(a+u,b+v), true;
  }
  return false;
}

int main(){
  vec3 a,b,a2,b2;
  cin>>a.x>>a.y>>a.z>>a2.x>>a2.y>>a2.z;
  cin>>b.x>>b.y>>b.z>>b2.x>>b2.y>>b2.z;
  cout<<a<<" "<<b<<endl;
  for (pfs(a,b,a,b,a2,b2); not pending_moves.empty(); pending_moves.pop()){
    a=pending_moves.top().first, b=pending_moves.top().second;
    cout<<a<<" "<<b<<endl;
  }
}
