#!/usr/bin/env python
import fileinput

class Point():
    def __init__(self,X,Y,Z):
        self.X = int(X)
        self.Y = int(Y)
        self.Z = int(Z)
        def __eq__(self, other):
            if isinstance(other, self.__class__):
                return self.X == other.X and self.Y == other.Y and self.Z == other.Z
            else:
                return False
        def __ne__(self, other):
            print "call my neq"
            return not self.__eq__(other)

def distance(P1,P2):
    return abs(P1.X-P2.X)+abs(P1.Y-P2.Y)+abs(P1.Z-P2.Z)

def Move_XYZ(P1,P2):
    B1 = (P1.X == P2.X)
    B2 = (P1.Y == P2.Y)
    B3 = (P1.Z == P2.Z)

    p1 = P1.X if B1 else (P1.X-1 if P1.X>P2.X else P1.X+1)
    p2 = P1.Y if (not B1 or B2) else (P1.Y-1 if P1.Y>P2.Y else P1.Y+1)
    p3 = P1.Z if (not B1 or not B2 or B3) else (P1.Z-1 if P1.Z>P2.Z else P1.Z+1)

    return Point(p1,p2,p3)

def head_on_collision(r1_traj,res1,r2_traj,res2):
    return abs(r1_traj.X-res1.X) == abs(r2_traj.X-res2.X) and abs(r1_traj.Y-res1.Y) == abs(r2_traj.Y-res2.Y) and abs(r1_traj.Z-res1.Z) == abs(r2_traj.Z-res2.Z)

i = 0
r = {}
for line in fileinput.input():
    r[i] = line.split()
    i += 1

r1_src = Point(r[0][0],r[0][1],r[0][2])
r1_traj = r1_src
r1_dst = Point( r[0][3],r[0][4],r[0][5])
r2_src = Point(r[1][0],r[1][1],r[1][2])
r2_traj = r2_src
r2_dst = Point(r[1][3],r[1][4],r[1][5])
print "(%d,%d,%d) (%d,%d,%d)" % (r1_traj.X,r1_traj.Y,r1_traj.Z,r2_traj.X,r2_traj.Y,r2_traj.Z)
while distance(r1_traj,r1_dst) + distance(r2_traj,r2_dst)>0:
    res1 = Move_XYZ(r1_traj,r1_dst)
    res2 = Move_XYZ(r2_traj,r2_dst)
    # clash or passing through each other?
    if distance(res1,res2) == 0 or ((distance(res1,r2_traj)==0 and distance(res2,r1_traj)==0)):
        # is it full-on collision?
        if head_on_collision(r1_traj,res1,r2_traj,res2):
            # both moving in X dir, robot 1 moves randomly away in Y dir
            if (abs(r1_traj.X-res1.X)!= 0):
                res1.X = r1_traj.X
                res1.Y = res1.Y+1
                res1.Z = res1.Z
            # both moving in Y dir, robot 1 moves randomly away in X dir
            elif (abs(r1_traj.Y-res1.Y)!= 0):
                res1.Y = r1_traj.Y
                res1.X = res1.X+1
                res1.Z = res1.Z
            # both moving in Z dir, R1 moves away randomly in X dir
            elif (abs(r1_traj.Z-res1.Z)!= 0):
                res1.Y = r1_traj.Y
                res1.X = res1.X+1
                res1.Z = res1.Z
            r1_traj = res1

        # just freeze for one move -- not full on collision
        # R2 does not care
        r2_traj = res2
    # all good, no clash
    else:
        r1_traj = res1
        r2_traj = res2
    print "(%d,%d,%d) (%d,%d,%d)" % (r1_traj.X,r1_traj.Y,r1_traj.Z,r2_traj.X,r2_traj.Y,r2_traj.Z)
