#!/usr/bin/env python
from sys import exit

# Maximum separation
s = int(raw_input())
assert 1 <= s <= 50000, 'Maximum separation (%d) is out of bounds' % (s)

# Number of waypoints followed by waypoints
w = int(raw_input())
assert 3 <= w <= 1000, 'Number of waypoints (%d) is out of bounds' % (w)

locations = map(int,raw_input().split())
assert len(locations) == len(set(locations)) == w, 'Duplicate locations'
assert locations == sorted(locations), 'Locations are not sorted'
assert locations[0] == 0, 'First location is not zero'

# Number of people followed by people
n = int(raw_input())
assert 2 <= n <= 1000, 'Number of hikers (%d) is out of bounds' % (n)

people = []
for i in range(n):
    people += [map(int, raw_input().split())]
    assert(1 <= people[-1][0] <= s)
    assert(1 <= people[-1][1] <= w)

    if i > 0:
        separation = max(people[-1][0],people[-2][0])
        assert people[-1][1] > people[-2][1], \
                'Persons %d and %d are not in order (vertices %d and %d respectively)' \
                % (i,i+1,people[-2][1],people[-1][1])

        dist = locations[people[-1][1]-1] - locations[people[-2][1]-1]
        assert dist >= separation, \
                'Persons %d and %d are too close together (dist=%d, must be at least %d)' \
                % (i,i+1,dist,separation)

        assert dist <= s, \
                'Persons %d and %d are too far apart (dist=%d, must be at most %d)' \
                % (i,i+1,dist,s)


exit(42)
