#!/usr/bin/env perl

use strict;
use warnings;

my $target_n = shift @ARGV // 20;
my $radius = shift @ARGV // 40000;
print STDERR "target n = $target_n\n";

sub rcent {
  return $_[0] + (int rand($_[1]*2+1)) - $_[1];
}

my $tx = rcent 0, 500000;
my $ty = rcent 0, 500000;
print "$tx $ty\n";

my %points = ();
for my $i (1 .. $target_n) {
  my $x = rcent $tx, $radius;
  my $y = rcent $ty, $radius;
  my $h = 1 + int rand 300000;
  $points{"$x $y"} = $h;
}

print((scalar keys %points) . "\n");
for my $i (keys %points) {
  my $h = $points{$i};
  print "$i $h\n";
}
