#!/usr/bin/env python
from bisect import bisect_left
from fractions import gcd
from math import atan2

def normalize(xy):
  l = gcd(abs(xy[0]), abs(xy[1]))
  return (xy[0] / l, xy[1] / l)

# Read input as (vector, distance, height) tuples
tvx,tvy = map(int, raw_input().split())
v = [map(int, raw_input().split()) for i in range(int(raw_input()))]
v = [(xy[0]-tvx,xy[1]-tvy,xy[2]) for xy in v]
v = [[normalize(xy), abs(xy[0])+abs(xy[1]), xy[2]] for xy in v]
v = sorted(v)

# Convert items into a flat list of numbers according to angle then height.
msf = 0
nmsf = 0
for i in range(len(v)):
  if i == 0 or v[i][0] <> v[i-1][0]:
    msf = nmsf
  v[i][2] += msf
  nmsf = max(nmsf, v[i][2]+1)
v = [xy[2] for xy in v]

def longest_increasing_subsequence(arr):
  res = []
  for i in arr:
    p = bisect_left(res, i)
    if p < len(res):
      res[p] = i
    else:
      res += [i]
  return len(res)

print longest_increasing_subsequence(v)
