#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
using namespace std;

int gcd(int a,int b){return b?gcd(b,a%b):a;}

struct vec2{
  int x,y;

  int length()const{
    int g=gcd(abs(x),abs(y));
    return g;
  }

  vec2 normalised()const{
    int g=max(length(),1);
    return {x/g,y/g};
  }

  bool operator<(vec2 const &a)const{
    return x!=a.x? x<a.x: y<a.y;
  }
};

int main(){
  vec2 tv; cin>>tv.x>>tv.y;
  map<vec2,vector<pair<int,int>>> angles;
  int n; cin>>n; while (n--){
    vec2 p; int h; cin>>p.x>>p.y>>h; p.x-=tv.x; p.y-=tv.y;
    angles[p.normalised()].emplace_back(p.length(),h);
  }

  int res=0;
  for (auto &item: angles){
    sort(item.second.begin(),item.second.end());
    map<int,int> dp={{0,0}};
    for (auto const &i: item.second){
      int const x=i.second;
      auto it=dp.lower_bound(x); --it;
      int score=max(dp[x],it->second+1);
      dp[x]=score;
      for (it=dp.upper_bound(x); it!=dp.end() and it->second<=score; dp.erase(it++));
    }
    res+=dp.rbegin()->second;
  }
  cout<<res<<endl;
}
