#include <algorithm>
#include <iostream>
#include <cmath>
using namespace std;

#define MAX_N 1000000

int gcd(int a,int b){return b?gcd(b,a%b):a;}

struct vec2{
  int x,y;

  int length()const{
    int g=gcd(abs(x),abs(y));
    return g;
  }

  vec2 normalised()const{
    int g=max(length(),1);
    return {x/g,y/g};
  }

  bool operator==(vec2 const &a)const{
    return x==a.x and y==a.y;
  }

  bool operator<(vec2 const &a)const{
    return x!=a.x? x<a.x: y<a.y;
  }
};

int main(){
  ios::sync_with_stdio(false);

  vec2 tv; cin>>tv.x>>tv.y;
  static pair<vec2,pair<int,int>> angles[MAX_N];
  int n; cin>>n;
  for (int i=0; i<n; i++){
    vec2 p; int h; cin>>p.x>>p.y>>h; p.x-=tv.x; p.y-=tv.y;
    angles[i]={p.normalised(),{p.length(),h}};
  }
  sort(angles,angles+n);

  int res=0;
  for (auto i=angles,j=i; i!=angles+n; i=j){
    while (j!=angles+n and i->first==j->first) ++j;
    static int patience[MAX_N];
    int patien=0;
    for (auto p=i; p!=j; p++){
      int const x=p->second.second;
      auto it=lower_bound(patience,patience+patien,x);
      *it=x;
      if (it==patience+patien) ++patien;
    }
    res+=patien;
  }
  cout<<res<<endl;
}
