import java.lang.Math.*
import java.util.*

data class Vec2(val x: Int, val y: Int) {}

class CompareVec2 {
  companion object : Comparator<Vec2> {
    override fun compare(a: Vec2, b: Vec2): Int = when {
      a.x != b.x -> a.x - b.x
      else -> a.y - b.y
    }
  }
}

fun gcd(a: Int, b: Int): Int {
  return if (b == 0) a else gcd(b, a%b)
}

fun length(v: Vec2): Int {
  return gcd(abs(v.x), abs(v.y))
}

fun normalised(v: Vec2): Vec2 {
  val g = length(v)
  return if (g > 0) Vec2(v.x/g, v.y/g) else v
}

fun main(args: Array<String>) {
  val scan = Scanner(System.`in`)
  val tv = Vec2(scan.nextInt(), scan.nextInt())

  val byAngle = TreeMap<Vec2, ArrayList<Vec2>>(CompareVec2)

  val n = scan.nextInt()
  for (i in 0 until n) {
    val p = Vec2(scan.nextInt() - tv.x, scan.nextInt() - tv.y)
    byAngle.getOrPut(normalised(p), {ArrayList<Vec2>()})
        .add(Vec2(length(p), scan.nextInt()))
  }

  var res = 0
  for (l in byAngle.values) {
    val patience = ArrayList<Int>()
    for (i in l.sortedBy({v -> v.x}).map({v -> v.y})) {
      var pos = patience.binarySearch(i)
      if (pos < 0) {
        pos = -(pos + 1)
        if (pos < patience.size) {
          patience.set(pos, i)
        } else {
          patience.add(i)
          res += 1
        }
      }
    }
  }

  System.`out`.println(res)
}
