//Greedy: takes the cheapest building and assings it to the department with the maximal number of students, which can fit into it.
//
//However it does not use a tree set which can be updated in O(logn) but array+binary search which can 
//
//degrade to running time O(m*n)
//
//

#include <bits/stdc++.h>
using namespace std;

typedef tuple<size_t, bool, size_t> Student;//number of students, index
typedef tuple<size_t, size_t, size_t> Building;//cost, capacity, index

int main(){
  size_t n,m; cin>>n>>m;
  

  vector<Student> students;
  for (size_t i=0; i<n; i++){
     size_t cnt; cin >> cnt;
     students.push_back(make_tuple(cnt, false, i)); 
  }
  sort(students.begin(), students.end());

  vector<Building> buildings(m);
  for (size_t i=0; i<m; i++) 
        get<2>(buildings[i])=i;
  for (auto &b: buildings) cin>>get<1>(b);
  for (auto &b: buildings) cin>>get<0>(b);
  sort(buildings.begin(),buildings.end());


  vector<size_t> res(n);
  size_t cnt=students.size();
  for (auto &b: buildings){
    if(cnt==0)
         break;
    //search for candidates
    vector<Student>::iterator it=upper_bound(students.begin(), students.end(), make_tuple(get<1>(b), true, 0));
    if(it==students.begin())//nothing found
        continue;
    do{                                                 //HERE WE GO, this step may need O(n)
      it--;//ok because there is at least 1 department
    }while(it!=students.begin() && get<1>(*it));
    
    if(get<1>(*it))    
        continue; //all were taken  
            
    res[get<2>(*it)]=get<2>(b);
    get<1>(*it)=true;
    cnt--;
  }
  
  if (cnt==0){
    for (size_t i=0;i<n;i++){
       if(i!=0) 
        cout << " ";
       cout << (res[i]+1);
    }
  }
  else 
    cout<<"impossible"<<endl;
  
  cout<<"\n";
}


