#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>

using namespace std;

struct Building {
	int cost;
	int size;
	int number;

	Building(int c, int s, int i) : cost(c), size(s), number(i) {}
};

struct largest_b {
	inline bool operator() (const Building& b1, const Building& b2) {
		if (b1.size == b2.size) {

			return (b1.cost > b2.cost);
		}
		return (b1.size > b2.size);
	}
};

struct smallest_r {
	inline bool operator() (int size, const Building& b1) {
		return (b1.size < size);
	}	
};

struct Dept {
	int number;
	int size;

	int building_no; 

	Dept(int n, int s) : number(n), size(s) {}
};

struct largest_d {
	inline bool operator() (const Dept& d1, const Dept& d2) {
		return (d1.size > d2.size);
	}
};

struct number_d {
	inline bool operator() (const Dept& d1, const Dept& d2) {
		return (d1.number < d2.number);
	}
};


int main(){

	int n,m; cin>>n>>m;

	if (m < n) {
		cout<<"impossible\n";
		exit(0);
	}

	vector<Dept> s;
	vector<Building> b;

	// Read all of the classes in.
	for(int i = 0; i<n; ++i) {
		int size; cin>>size;
		s.push_back(Dept(i, size));
	}
	// Sort the array to be largest first.
	sort(s.begin(), s.end(), largest_d());

	// for(int o =0; o < n; ++o) {
	// 	cout<<"dept size="<<s[o].size<<"\n";
	// }

	// Read all of the buildings into an array
	int * t = new int[m];

	for(int i = 0; i<m; ++i) {
		cin>>t[i];
	}
	for(int i = 0; i<m; ++i) {
		int cost; cin>>cost;
		b.push_back(Building(cost, t[i], i));
	}
	sort(b.begin(), b.end(), largest_b());

	// for(int o =0; o < m; ++o) {
	// 	cout<<"buildin size="<<b[o].size<<", cost="<<b[o].cost<<"\n";
	// }

	// Now, iterate over the departments, for each one find the
	// smallest building that can fit.
	for(int i = 0; i<n; i++) {
		auto s_r = upper_bound(b.begin(), b.end(), s[i].size, smallest_r());
		int pos = s_r - b.begin();
		// pos will be the index of the first building who's size is LESS THAN OR EQUAL
		// the size we need.
		if(pos == 0 && b[0].size < s[i].size) {
			// if we're looking at the first one and its too small. impossible.
			cout<<"impossible\n";
			exit(0);
		} else {
			pos--;
		}
		//  else if(s_r != b.end()) {
		// 	// If we're not on the last item, check the next one as it might be equal.
		// 	if (b[pos + 1].size == s[i].size) {
		// 		pos++;
		// 	}
		// }
	

		int sm_cost = 2000,sm_idx = pos;
		//cout<<"lower_bound pos="<<sm_idx<<", size="<<b[sm_idx].size<<", cost="<<b[sm_idx].cost<<"\n";
		for(int j = sm_idx; j>=0; --j) {
		//	cout<<"checking="<<j<<", size="<<b[j].size<<", cost="<<b[j].cost<<"\n";
			if (b[j].cost < sm_cost) {
				sm_cost = b[j].cost;
				sm_idx = j;
			}
		}

//cout<<"matched="<<sm_idx<<", size="<<b[sm_idx].size<<", cost="<<b[sm_idx].cost<<"\n";
		s[i].building_no = b[sm_idx].number;
		b.erase(b.begin() + sm_idx);
	}

	// Sort the building array back to the right order.
	sort(s.begin(), s.end(), number_d());

	for(int i = 0; i < n; ++i) {
		if (i > 0) {
			cout<<" ";
		}
		cout<<(s[i].building_no + 1);
	}
	cout<<"\n";
}
