#include <algorithm>
#include <iostream>
#include <cassert>
#include <utility>
#include <vector>
#include <tuple>
using namespace std;
typedef tuple<int,int,int> tp;

// Same as sorting.cc but with a skiplist instead of std::set

namespace dsu{
  vector<int> p,r,link;
  void init(int n){
    p.resize(n);
    r.resize(n);
    link.resize(n);
    while (n--) p[n]=link[n]=n;
  }
  int root(int a){
    return p[a]==a? a: p[a]=root(p[a]);
  }
  bool merge(int a,int b){
    a=root(a),b=root(b);
    if (a==b) return false;
    if (r[a]<r[b]) swap(a,b);
    link[a]=max(link[a],link[b]);
    p[b]=a;
    ++r[a];
    return true;
  }
}

int main(){
  ios::sync_with_stdio(false);
  int n,m; cin>>n>>m;
  vector<int> res(n);
  vector<bool> gone(n);
  dsu::init(n+1);

  vector<pair<int,int>> pop;
  for (int i=0,x; i<n; i++) cin>>x, pop.push_back({-x,i});
  sort(pop.begin(),pop.end());

  vector<tp> v(m);
  for (int i=0; i<m; i++) get<2>(v[i])=i;
  for (auto &i: v) cin>>get<1>(i);
  for (auto &i: v) cin>>get<0>(i);
  sort(v.begin(),v.end());
  int solved=0;

  for (auto &i: v){
    int x=lower_bound(pop.begin(),pop.end(),make_pair(-get<1>(i),0))-pop.begin();
    if (x!=n){
      x=dsu::link[dsu::root(x)];
    }
    if (x!=n){
      res[pop[x].second]=get<2>(i)+1;
      gone[x]=true;
      dsu::merge(x,x+1);
//      if (x and gone[x-1]) dsu::merge(x,x-1);
      ++solved;
    }
  }
  if (solved<n){
    cout<<"impossible"<<endl;
  }
  else for (int i=0; i<n; i++){
    assert(0<res[i] and res[i]<=m);
    cout<<res[i]<<(i+1==n?'\n':' ');
  }
}
