#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
using namespace std;

struct Room{
  int id;
  int size;
  int cost;
};

bool byId(Room const &a,Room const &b){return a.id<b.id;}
bool byCost(Room const &a,Room const &b){return a.cost!=b.cost? a.cost>b.cost: byId(a,b);}
bool bySize(Room const &a,Room const &b){return a.size!=b.size? a.size<b.size: byId(a,b);}

struct CostComparator{bool operator()(Room const &a,Room const &b)const{return byCost(a,b);}};
struct SizeComparator{bool operator()(Room const &a,Room const &b)const{return bySize(a,b);}};

int main(){
  int n,m; cin>>n>>m;

  vector<Room> deps(n);
    {int i=0; for (auto &d: deps) cin>>d.size, d.id=i++;}
  vector<Room> rooms(m);
    {int i=0; for (auto &r: rooms) cin>>r.size, r.id=i++;}
    {int i=0; for (auto &r: rooms) cin>>r.cost;}

  priority_queue<Room,vector<Room>,CostComparator> roomsByCost;
  priority_queue<Room,vector<Room>,SizeComparator> roomsBySize(rooms.begin(),rooms.end());

  sort(deps.rbegin(),deps.rend(),&bySize);
  for (auto &d: deps){
    while (not roomsBySize.empty() and roomsBySize.top().size>=d.size){
      roomsByCost.push(roomsBySize.top());
      roomsBySize.pop();
    }
    if (roomsByCost.empty()){
      cout<<"impossible"<<endl;
      return 0;
    }
    d.cost=roomsByCost.top().id;
    roomsByCost.pop();
  }
  sort(deps.begin(),deps.end(),&byId);

  for (int i=0; i<deps.size(); i++){
    cout<<deps[i].cost+1<<(i+1==deps.size()? "\n": " ");
  }
}
