import java.util.*;
import java.io.*;

public class jeroen_nobuildsort
{
	public static void main(String[] args) throws Exception
	{
		// Read input
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String[] ps = in.readLine().split(" ");
		int n = Integer.valueOf(ps[0]);
		int m = Integer.valueOf(ps[1]);
		
		int[] s = new int[n];
		ps = in.readLine().split(" ");
		for(int i = 0; i < n; i++)
			s[i] = Integer.valueOf(ps[i]);
		
		int[] p = new int[m];
		ps = in.readLine().split(" ");
		for(int i = 0; i < m; i++)
			p[i] = Integer.valueOf(ps[i]);
		
		int[] r = new int[m];
		ps = in.readLine().split(" ");
		for(int i = 0; i < m; i++)
			r[i] = Integer.valueOf(ps[i]);

		// Solve greedily
		Department[] d = new Department[n];
		for(int i = 0; i < n; i++)
			d[i] = new Department(s[i], i);
		Arrays.sort(d);
		
		Building[] b = new Building[m];
		for(int i = 0; i < m; i++)
			b[i] = new Building(1 + i, p[i], r[i]);
		//Arrays.sort(b);

		int[] ret = new int[n];
		for(int i = 0; i < n; i++) {
			int j = 0;
			while(j < m && (b[j].occupied || b[j].cap < d[i].size))
				j++;
			if (j == m) {
				System.out.println("impossible");
				return;
			}
			ret[d[i].idx] = b[j].num;
			b[j].occupied = true;
		}
		for(int i : ret) System.out.print(i + " ");
		System.out.println();
	}
}

class Building implements Comparable<Building> {
	public int num, cap, cost;
	public boolean occupied = false;

	public Building(int num, int cap, int cost) {
		this.num = num;
		this.cap = cap;
		this.cost = cost;
	}

	public int compareTo(Building other) {
		return cost - other.cost;
	}
}

class Department implements Comparable<Department> {
	public int size, idx;

	public Department(int size, int idx) {
		this.size = size;
		this.idx = idx;
	}

	public int compareTo(Department other) {
		return other.size - size;
	}
}
