#include <stdint.h>
#include <stdio.h>

typedef struct {
    int length;
    int start;
    int end;
} World;

int main(int argc, char **argv) {
    int n; scanf("%d", &n);

    static World worlds[20];
    int longest = 0;

    for (int i = 0; i < n; ++i) {
        scanf("%d %d %d", &worlds[i].length, &worlds[i].start, &worlds[i].end);
        ++worlds[i].start;
        if (worlds[i].start > worlds[i].end) {
            worlds[i].start -= worlds[i].length;
        }
        if (i == 0 || worlds[i].length > longest) {
            longest = worlds[i].length;
        }
    }

    int hours = 1825 * longest;
    static int8_t change[1825 * 100];
    for (int i = 0; i < n; ++i) {
        for (int j = worlds[i].start; j < hours; j += worlds[i].length) {
            ++change[j < 0 ? 0 : j];
        }
        for (int j = worlds[i].end; j < hours; j += worlds[i].length) {
            --change[j];
        }
    }

    for (int i = 0, cur = 0; i < hours; i++) {
        cur += change[i];
        if (cur == 0) {
            printf("%d\n", i);
            return 0;
        }
    }
    puts("impossible");
    return 0;
}
