#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

struct Planet{
  float sunrise;
  float sunset;
  int hours;
};


// We keep a span of hours of darkness. FIrst time around make rhe WHOLE time dark.
// Then we work our the days that will take place on the next planet. Then make the span
// smaller to fit the overlap. 

int overlap(int sunset, int sunrise, int p_idx, vector<Planet> p) {
	//cout<<"sunset="<<sunset<<", sunrise="<<sunrise<<'\n';
	//cout<<"p_idx="<<p_idx<<'\n';
    //cout<<"hours="<<p[p_idx].hours<<'\n';
	int low_idx = sunset / p[p_idx].hours;
	//cout<<"low_idx="<<low_idx<<'\n';
	int high_idx = sunrise / p[p_idx].hours;
	//cout<<"high_idx="<<high_idx<<'\n';

	for (int t = low_idx; t <= high_idx; ++t) {
		int new_sunset = fmax((t * p[p_idx].hours) + p[p_idx].sunset, sunset);
		int new_sunrise = fmin((t * p[p_idx].hours) + p[p_idx].sunrise, sunrise);

//cout<<"new sunset="<<new_sunset<<'\n';
//cout<<"new sunrise="<<new_sunrise<<'\n';
		if (new_sunrise < sunset) {
			continue;
		}
		if (new_sunset > sunrise) {
			continue;
		}
		//cout<<"size="<<p.size()<<'\n';
		if (new_sunset <= sunset) {
			if (p_idx == p.size() -1 ) {
				return sunset;			
			} else {
				int ov = overlap(sunset, fmin(new_sunrise, sunrise), p_idx+1, p);
				if (ov == -1) {
					continue;
				}
				return ov; 
			}
		} else {
			if (p_idx == p.size() -1 ) {
				return new_sunset;			
			} else {
				int ov = overlap(new_sunset, fmin(new_sunrise, sunrise), p_idx+1, p);
				if (ov == -1) {
					continue;
				}
				return ov; 
			}
		}
	}
	return -1;
};

int main(){
	int planets; cin>>planets;
	vector<Planet> p(planets);
  int longest_day = 0;
	for(int i = 0; i < planets; ++i) {
	 	cin>>p[i].hours>>p[i].sunrise>>p[i].sunset;
	 	if(p[i].sunset > p[i].sunrise) {
	 		p[i].sunset = p[i].sunset - p[i].hours; // make it negative.
	 	}
    longest_day = max(longest_day, p[i].hours);
	}
	int bob = overlap(0, longest_day*1825, 0, p);

	if (bob != -1) {
		cout<<bob<<'\n';
	} else {
		cout<<"impossible\n";
	}
}
